#!/usr/bin/perl
# Change the line above the reflect the path to Perl.

# Version 2.2 Beta

use CGI;

my $VARFILE = 'vars.dat';
my $q = new CGI;
my $VARSEP = '``z';
my %TPVARS = ();
my %Cookies = ();

init();

## CORE TAG BOARD STUFF #########################################

my $name = $q->param('name');
my $url	= $q->param('url');
my $msg	= $q->param('msg');

$name =~ s/\n/ /g;
$url =~ s/\n/ /g;
$msg =~ s/\n/ /g;
$name =~ s/\r/ /g;
$url =~ s/\r/ /g;
$msg =~ s/\r/ /g;
$name =~ s/"/&quot;/g;
$url =~ s/"/&quot;/g;
$msg =~ s/"/&quot;/g;

if($url =~ /.*\..+/) {
	$url = 'http://' . $url if($url !~ m!^http://!)
} else {
	$url = '';
};

error_msg($TPVARS{'msg_no_data'}) unless ($name && $msg);
my $content = $name . $url . $msg;
error_msg($TPVARS{'msg_long_tag'}) if (length($content) > $TPVARS{'max_content_size'});
error_msg($TPVARS{'msg_html_chars'}) if ($content =~ /</ || $content =~ />/);

(my $namestripped = $name) =~ s/\s//g;
if(lc($namestripped) eq lc($TPVARS{'admin_uname'})) {
	my $pw = $q->param('pw');
	if(!$pw) {
		GetCookies();
		if($Cookies{'uname'} ne $TPVARS{'admin_uname'} || $Cookies{'pword'} ne $TPVARS{'admin_pword'}) {
			print $q->header;
			print <<"EOF";
<html>
	<body>
		<form method="POST">
			<center>
			PW: <input type="password" name="pw" size="8">
			<br><input type="submit" value="submit">
			</center>
			<input type="hidden" name="name" value="$name">
			<input type="hidden" name="url" value="$url">
			<input type="hidden" name="msg" value="$msg">
		</form>
	</body>
</html>
EOF
			exit;
		}
	} else {
		error_msg($TPVARS{'msg_inv_admin_pw'}) if($pw ne $TPVARS{'admin_pword'});
	}
} else {

	my @bad_words = split(/ /, $TPVARS{'bad_words'});
	for (@bad_words) {
		error_msg($TPVARS{'msg_vulgarity'}) if ($content =~ /$_/i && $_ ne '');
	}

	my @words = ($name, split(/ /, $msg));
	for (@words) {
		error_msg($TPVARS{'msg_word_max_chars'})
			if(length > $TPVARS{'word_max_chars'});
	}


	# TODO: use flock

	my $ip = $ENV{'REMOTE_ADDR'};
	my $cur_time = time;
	open IP, $TPVARS{'ip_logfile'};
	my $old_time = <IP>;
	chop($old_time);
   
	if($old_time + $TPVARS{'time_limit'} > $cur_time) {
		while(<IP>) {
			chop;
			if($ip eq $_) {
				close IP;
				error_msg($TPVARS{'msg_time_limit'});
			}
		}
		close IP;
		open IP, ">>$TPVARS{'ip_logfile'}";
	} else {
		close IP;
		open IP, ">$TPVARS{'ip_logfile'}";
		print IP "$cur_time\n";
	}
	print IP "$ip\n";
	close IP;

}

open DAT, $TPVARS{'tag_dat'};
my @tag_data = <DAT>;
close DAT;

my $tag_id = $#tag_data + 1;

unshift @tag_data, (join('<>', ($tag_id, time, $ENV{'REMOTE_ADDR'}, $name, $url, $msg)) . "\n");

open DAT, ">$TPVARS{'tag_dat'}";
print DAT @tag_data;
close DAT;

my @board;

for(@tag_data) {
	chomp;
	($tag_id, $time, $ip, $name, $url, $msg) = split /<>/;
   $name = "<a href=\"$url\" target=\"blank\">$name</a>" if($url);
   $content = "$name$TPVARS{'separator'}$msg<br>\n";
   push @board, $content;
}

my $mt = $TPVARS{'max_tags'} - 1;
$#board = $mt if ($#board > $mt);

push @board, '';

open TAG, ">$TPVARS{'tag_path'}";
print TAG @board;
close TAG;

if ($TPVARS{'auto_redirect'}) {
	print "Location: $TPVARS{'return_path'}\n\n";
} else {
	my $m = $TPVARS{'msg_tagged'};
	$m =~ s/RETURN_PATH/$TPVARS{'return_path'}/g;
	print $q->header;
	print <<"EOF";
<html>
	<body>
		$m
	</body>
</html>
EOF
}

exit; 

#################################################################

sub init {

	if($ENV{'QUERY_STRING'} eq 'origin') {
		print $q->header; print ''; exit;
	}

	open VARS, $VARFILE or error_msg("Could not open data file.");
	my @vars = <VARS>;
	close VARS;
   
	my $varname;
	my $varvalue;
   
	for (@vars) {
		chomp;
		($varname, $varvalue) = split /$VARSEP/;
		$TPVARS{$varname} = $varvalue;
	}

}

#################################################################

sub error_msg {
	my $m = shift;
	print $q->header;
	print <<"EOF";
<html>
	<body>
		<p align="center">
		<b>Error</b>: $m
		<p align="center"><a href="$TPVARS{'return_path'}">OK</a>
	</body>
</html>
EOF
exit;
}

#################################################################

sub GetCookies {

	my @Cookie_Decode_Chars = ('\+', '\%3A\%3A', '\%26', '\%3D', '\%2C', '\%3B', '\%2B', '\%25');
	my %Cookie_Decode_Chars = ('\+', ' ', '\%3A\%3A', '::', '\%26', '&', '\%3D', '=', '\%2C', ',', '\%3B', ';',	 '\%2B', '+', '\%25', '%');

	my $cookie; my $value; my $char;

	if ($ENV{'HTTP_COOKIE'}) {
		foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
			($cookie,$value) = split(/=/);
			foreach $char (@Cookie_Decode_Chars) {
				$cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
				$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
			}
			$Cookies{$cookie} = $value;
		}
	}

}

#################################################################
